$.fn.loadTemplates = function() {
  $.JST.loadTemplates($(this));
  return this;
};

$.JST = {
  _templates: new Object(),
  _decorators:new Object(),

  loadTemplates: function() {
    const elems = $(this.templates);
    elems.each(function() {
      $(this).find(".__template__").each(function() {
          var tmpl = $(this);
          var type = tmpl.attr("type");

          //template may be inside <!-- ... --> or not in case of ajax loaded templates
          var found=false;
          var el=tmpl.get(0).firstChild;
          while (el && !found) {
            if (el.nodeType == 8) { // 8==comment
              var templateBody = el.nodeValue; // this is inside the comment
              found=true;
              break;
            }
            el=el.nextSibling;
          }
          if (!found)
            var templateBody = tmpl.html(); // this is the whole template

          if (!templateBody.match(/##\w+##/)) { // is Resig' style? e.g. (#=id#) or (# ...some javascript code 'obj' is the alias for the object #)
            var strFunc =
                    "var p=[],print=function(){p.push.apply(p,arguments);};" +
                    "with(obj){p.push('" +
                    templateBody.replace(/[\r\t\n]/g, " ")
                            .replace(/'(?=[^#]*#\))/g, "\t")
                            .split("'").join("\\'")
                            .split("\t").join("'")
                            .replace(/\(#=(.+?)#\)/g, "',$1,'")
                            .split("(#").join("');")
                            .split("#)").join("p.push('")
                            + "');}return p.join('');";

          try {
            $.JST._templates[type] = new Function("obj", strFunc);
          } catch (e) {
            console.error("JST error: "+type, e,strFunc);
          }

          } else { //plain template   e.g. ##id##
          try {
            $.JST._templates[type] = templateBody;
          } catch (e) {
            console.error("JST error: "+type, e,templateBody);
          }
          }

          tmpl.remove();

      });
    });
    },

    /*
     * start es6 -> es5
     * 
     * templates: `
     * <div id="gantEditorTemplates" style="display: none">
     *   <div class="__template__" type="TASK_EDITOR">
     *     <!--
     *     <div class="pluginGantt_ganttTaskEditor">
     *         <h2 class="pluginGantt_taskData">Task editor</h2>
     *         <h2>Assignments</h2>
     *         <table  cellspacing="1" cellpadding="0" width="100%" class="pluginGantt_assigsTable">
     *         <tr>
     *             <th style="width:100px;">name</th>
     *             <th style="width:70px;">Role</th>
     *             <th style="width:30px;">est.wklg.</th>
     *             <th style="width:30px;" class="pluginGantt_addAssig"><span class="pluginGantt_teamworkIcon" style="cursor: pointer">+</span></th>
     *         </tr>
     *         </table>
     *         <div style="text-align: right; padding-top: 20px">
     *             <span class="pluginGantt_saveButton pluginGantt_button first" onClick="$(this).trigger('saveFullEditor.gantt');">Save</span>
     *         </div>
     *     </div>
     *     -->
     *   </div>
     * 
     *   <div class="__template__" type="ASSIGNMENT_ROW">
     *     <!--
     *     <tr taskId="(#=obj.task.id#)" assId="(#=obj.assig.id#)" class="pluginGantt_assigEditRow" >
     *         <td ><select name="resourceId"  class="pluginGantt_formElements" (#=obj.assig.id.indexOf("tmp_")==0?"":"disabled"#) ></select></td>
     *         <td ><select type="select" name="roleId"  class="pluginGantt_formElements"></select></td>
     *         <td ><input type="text" name="effort" value="(#=getMillisInHoursMinutes(obj.assig.effort)#)" size="5" class="pluginGantt_formElements"></td>
     *         <td align="center"><span class="pluginGantt_teamworkIcon pluginGantt_delAssig del" style="cursor: pointer">d</span></td>
     *     </tr>
     *     -->
     *   </div>
     * 
     *   <div class="__template__" type="RESOURCE_ROW">
     *     <!--
     *     <tr resId="(#=obj.id#)" class="pluginGantt_resRow" >
     *         <td ><input type="text" name="name" value="(#=obj.name#)" style="width:100%;" class="pluginGantt_formElements"></td>
     *         <td align="center"><span class="pluginGantt_teamworkIcon pluginGantt_delRes del" style="cursor: pointer">d</span></td>
     *     </tr>
     *     -->
     *   </div>
     * </div>`,
     */
    template: "<div id=\"gantEditorTemplates\" style=\"display: none\">\n      <div class=\"__template__\" type=\"TASK_EDITOR\">\n        <!--\n        <div class=\"pluginGantt_ganttTaskEditor\">\n            <h2 class=\"pluginGantt_taskData\">Task editor</h2>\n            <h2>Assignments</h2>\n            <table  cellspacing=\"1\" cellpadding=\"0\" width=\"100%\" class=\"pluginGantt_assigsTable\">\n            <tr>\n                <th style=\"width:100px;\">name</th>\n                <th style=\"width:70px;\">Role</th>\n                <th style=\"width:30px;\">est.wklg.</th>\n                <th style=\"width:30px;\" class=\"pluginGantt_addAssig\"><span class=\"pluginGantt_teamworkIcon\" style=\"cursor: pointer\">+</span></th>\n            </tr>\n            </table>\n            <div style=\"text-align: right; padding-top: 20px\">\n                <span class=\"pluginGantt_saveButton pluginGantt_button first\" onClick=\"$(this).trigger('saveFullEditor.gantt');\">Save</span>\n            </div>\n        </div>\n        -->\n      </div>\n\n      <div class=\"__template__\" type=\"ASSIGNMENT_ROW\">\n        <!--\n        <tr taskId=\"(#=obj.task.id#)\" assId=\"(#=obj.assig.id#)\" class=\"pluginGantt_assigEditRow\" >\n            <td ><select name=\"resourceId\"  class=\"pluginGantt_formElements\" (#=obj.assig.id.indexOf(\"tmp_\")==0?\"\":\"disabled\"#) ></select></td>\n            <td ><select type=\"select\" name=\"roleId\"  class=\"pluginGantt_formElements\"></select></td>\n            <td ><input type=\"text\" name=\"effort\" value=\"(#=getMillisInHoursMinutes(obj.assig.effort)#)\" size=\"5\" class=\"pluginGantt_formElements\"></td>\n            <td align=\"center\"><span class=\"pluginGantt_teamworkIcon pluginGantt_delAssig del\" style=\"cursor: pointer\">d</span></td>\n        </tr>\n        -->\n      </div>\n\n      <div class=\"__template__\" type=\"RESOURCE_ROW\">\n        <!--\n        <tr resId=\"(#=obj.id#)\" class=\"pluginGantt_resRow\" >\n            <td ><input type=\"text\" name=\"name\" value=\"(#=obj.name#)\" style=\"width:100%;\" class=\"pluginGantt_formElements\"></td>\n            <td align=\"center\"><span class=\"pluginGantt_teamworkIcon pluginGantt_delRes del\" style=\"cursor: pointer\">d</span></td>\n        </tr>\n        -->\n      </div>\n    </div>",
    /* end es6 -> es5 */

  createFromTemplate: function(jsonData, template, transformToPrintable) {
    var templates = $.JST._templates;

    var jsData=new Object();
    if (transformToPrintable){
      for (var prop in jsonData){
        var value = jsonData[prop];
        if (typeof(value) == "string")
          value = (value + "").replace(/\n/g, "<br>");
        jsData[prop]=value;
      }
    } else {
      jsData=jsonData;
    }

    function fillStripData(strip, data) {
      for (var prop in data) {
        var value = data[prop];

        strip = strip.replace(new RegExp("##" + prop + "##", "gi"), value);
      }
      // then clean the remaining ##xxx##
      strip = strip.replace(new RegExp("##\\w+##", "gi"), "");
      return strip;
    }

    var stripString = "";
    if (typeof(template) == "undefined") {
      alert("Template is required");
      stripString = "<div>Template is required</div>";

    } else if (typeof(templates[template]) == "function") { // resig template
      try {
        stripString = templates[template](jsData);// create a jquery object in memory
      } catch (e) {
        console.error("JST error: "+template,e.message);
        stripString = "<div> ERROR: "+template+"<br>" + e.message + "</div>";
      }

    } else {
      stripString = templates[template]; // recover strip template
      if (!stripString || stripString.trim() == "") {
        console.error("No template found for type '" + template + "'");
        return $("<div>");

      } else {
        stripString = fillStripData(stripString, jsData); //replace placeholders with data
      }
    }

    var ret = $(stripString);// create a jquery object in memory
    ret.attr("__template", template); // set __template attribute

    //decorate the strip
    var dec = $.JST._decorators[template];
    if (typeof (dec) == "function")
      dec(ret, jsData);

    return ret;
  },


  existsTemplate: function(template) {
    return $.JST._templates[template];
  },

  //decorate function is like function(domElement,jsonData){...}
  loadDecorator:function(template, decorator) {
    $.JST._decorators[template] = decorator;
  },

  getDecorator:function(template) {
    return $.JST._decorators[template];
  },

  decorateTemplate:function(element) {
    var dec = $.JST._decorators[element.attr("__template")];
    if (typeof (dec) == "function")
      dec(editor);
  },

  // asynchronous
  ajaxLoadAsynchTemplates: function(templateUrl, callback) {

    $.get(templateUrl, function(data) {

      var div = $("<div>");
      div.html(data);

      $.JST.loadTemplates(div);

      if (typeof(callback == "function"))
        callback();
    },"html");
  },

  ajaxLoadTemplates: function(templateUrl) {
    $.ajax({
      async:false,
      url: templateUrl,
      dataType: "html",
      success: function(data) {
        var div = $("<div>");
        div.html(data);
        $.JST.loadTemplates(div);
      }
    });

  }


};
